<template>
	<div class="admin-role-component">
		<h1>Admin Role Component</h1>
		<section>
			<h2>Modifier le role d'un utilisateur</h2>
			<form>
				<label for="userEmail">
					<span>Utilisateur</span>
					<select
						v-model="userSelected"
						name="user">
						<option
							v-for="user in users"
							:key="user.email"
							:value="user.email">
							{{ user.email }} - {{ user.role }}
						</option>
					</select>
				</label>
				<label for="role">
					<span>Nouveau role de l'utilisateur</span>
					<select
						v-model="roleSelected"
						name="role">
						<option
							v-for="role in roles"
							:key="role"
							:value="role">
							{{ role }}
						</option>
					</select>
				</label>
				<button
					type="submit"
					@click="submitUpdateUserRole">
					Click Here
				</button>
			</form>
		</section>
		<hr />
	</div>
</template>

<script lang="ts">
	import { defineComponent } from "vue"
	import type { User } from "#/user"
	import { Role, useUser } from "@/composables/useUser.composable"

	interface Data {
		users: User[]
		userSelected: string
		roles: Role[]
		roleSelected: string
	}

	const token = localStorage.getItem("token")

	export default defineComponent({
		name: "AdminRoleComponent",
		data(): Data {
			return {
				users: [],
				userSelected: "",
				roles: [Role.STUDENT, Role.INSTRUCTOR, Role.TEACHER, Role.ADMIN],
				roleSelected: "",
			}
		},
		methods: {
			async submitUpdateUserRole(e: Event) {
				e.preventDefault()
				const email = this.userSelected
				const role = this.roleSelected as Role
				if (!useUser().canUpdateUserRole(token, { email: email, role: role })) {
					alert("You are not allowed to update this user's role")
					return
				} else {
					// TODO: Update the user's role in the database
					const result = await useUser().updateRole(token as string, { email: email, role: role })
					if (result.valid) {
						alert("Role updated")
						await this.refreshUsers(token as string)
					} else {
						alert(result.error)
					}
				}
			},
			async refreshUsers(token: string) {
				if (token === null) {
					alert("You are not allowed to access this page or your session has expired")
					location.href = "/"
				} else {
					const result = await useUser().getAllUsers(localStorage.getItem("token") as string)
					if (result === null) {
						alert("You are not allowed to access this page or your session has expired")
						location.href = "/"
					} else {
						this.users = result
					}
				}
			},
		},
		async mounted() {
			await this.refreshUsers(token as string)
		},
	})
</script>

<style lang="scss" scoped>
	.admin-role-component {
		width: 80vw;
		margin: 0 auto;

		section {
			width: 60vw;
			margin: auto 20vh;

			h2 {
				font-size: 2em;
				text-align: center;
				margin-bottom: 1vh;
			}

			form {
				width: max-content;
				margin: 0 auto;
				display: flex;
				flex-direction: column;
				font-size: 1em;

				label {
					margin-bottom: 2vh;

					span {
						margin-right: 0.5vw;
					}
				}

				button {
					margin-top: 2vh;
					width: fit-content;
					align-self: center;
				}
			}
		}

		hr {
			display: block;
			border: 1px solid white;
			width: 40vw;
			margin-top: 5vh;
			margin-bottom: 5vh;
			text-align: center;
		}
	}
</style>
